
//**********************************************************************************************
//       R2 R3 R4
//      R1 = ATR*Kof  12   SMA 
//       Buy  Sell   
//   12  (  )  High/Low     
// .      . 
// 
//     R3 R4 ATR * kof
// : 
//-----         
// 2.period  -        . 
//-----         
// 4.min_order -          
//                .  
// 5.koef_ATR     =    1.5;  
//-----         
//+===========================================================================+ 
#property indicator_chart_window 
#property indicator_buffers       6         
#property indicator_color1        Gray
#property indicator_color2        Gray
#property indicator_color3        Gray
#property indicator_color4        Gray
#property indicator_color5        Gray
#property indicator_color6        Gray

//-----         
extern int      period_Teni     =     12; 
extern int      period_ATR      =     12;
extern double   min_order       =     16;  
extern double   koef_R          =    1.5;  
       double   spred           =     0;

//-----         
double Buf_R2_Buy[], 
       Buf_R2_Sel[],
       Buf_R3_Buy[],
       Buf_R3_Sel[],
       Buf_R4_Buy[],
       Buf_R4_Sel[]; 
//+===========================================================================+ 
int init() 
   { 
     SetIndexBuffer (0, Buf_R2_Buy); 
     SetIndexStyle  (0, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (0,"Profit_R2_Buy");
    //-----         
     SetIndexBuffer (1, Buf_R2_Sel);  
     SetIndexStyle  (1, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (1,"Profit_R2_Sell");
     
     SetIndexBuffer (2, Buf_R3_Buy); 
     SetIndexStyle  (2, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (2,"Profit_R3_Buy");
    //-----         
     SetIndexBuffer (3, Buf_R3_Sel);  
     SetIndexStyle  (3, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (3,"Profit_R3_Sell");
     
     SetIndexBuffer (4, Buf_R4_Buy); 
     SetIndexStyle  (4, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (4,"Profit_R4_Buy");
    //-----         
     SetIndexBuffer (5, Buf_R4_Sel);  
     SetIndexStyle  (5, DRAW_LINE, STYLE_DOT, 1); 
     SetIndexLabel  (5,"Profit_R4_Sell");
      
    return(0); 
   } 
//+===========================================================================+ 
int start() 
   { 
   int    i,n,counted_bars=IndicatorCounted();
   if(Bars<=period_Teni) return(0);
   
   if(counted_bars<1){
     for(i=1;i<=period_Teni;i++){
        Buf_R2_Buy[Bars-i]=0; 
        Buf_R2_Sel[Bars-i]=0;
        Buf_R3_Buy[Bars-i]=0;
        Buf_R3_Sel[Bars-i]=0;
        Buf_R4_Buy[Bars-i]=0;
        Buf_R4_Sel[Bars-i]=0;
     }
   } 
   
   i=Bars-period_Teni-1;

   if(counted_bars>=period_Teni) i=Bars-counted_bars-1;
   
      while(i>=0){
           spred = (MarketInfo(Symbol(),MODE_SPREAD))*Point;  //---  . 
           double V_Pos = 0, V_Neg = 0, Sum_ATR = 0; 
           //-------------------------------------------------------------------------
            for (n = i; n < i + period_Teni; n++) //   21.04.2010
            
                { 
                  Sum_ATR = Sum_ATR + (High [n] - Low[n]);
                
                   if (Close[n] > Open[n]) V_Pos = V_Pos + (High [n] - Close[n]); 
                   else                    V_Pos = V_Pos + (High [n] - Open [n]);     
                //-----  
                   if (Close[n] < Open[n]) V_Neg = V_Neg + (Close[n] - Low  [n]); 
                   else                    V_Neg = V_Neg + (Open [n] - Low  [n]);     
                } 
           //--------------------------------------------------------------------------         
            double Vsr_Pos = High[i] + (V_Pos / period_Teni) + spred, 
                   Vsr_Neg = Low[i]  - (V_Neg / period_Teni), 
                   ATR = iATR(NULL,0,period_ATR,i), R = ATR * koef_R; 

            //-------------------------------------------------------------------------
             
           //-----  
            if (Vsr_Pos < High[i] + min_order * Point + spred)  
                Vsr_Pos = High[i] + min_order * Point + spred; 
           //-----  
            if (Vsr_Neg > Low[i]  - min_order * Point)  
                Vsr_Neg = Low[i]  - min_order * Point; 

                
            
            double   R2_Buy = Vsr_Pos + 2*R, R2_Sel = Vsr_Neg - 2*R + spred,
                     R3_Buy = Vsr_Pos + 3*R, R3_Sel = Vsr_Neg - 3*R + spred,
                     R4_Buy = Vsr_Pos + 4*R, R4_Sel = Vsr_Neg - 4*R + spred;
            
           //-----  
            
           //-----  
            Buf_R2_Buy[i]= R2_Buy; 
            Buf_R2_Sel[i]= R2_Sel;
            Buf_R3_Buy[i]= R3_Buy;
            Buf_R3_Sel[i]= R3_Sel;
            Buf_R4_Buy[i]= R4_Buy; 
            Buf_R4_Sel[i]= R4_Sel; 
           i--; 
          } 
      return(0); 
   } 
//+===========================================================================+  



